VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2175
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2070
   LinkTopic       =   "Form1"
   ScaleHeight     =   2175
   ScaleWidth      =   2070
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   375
      Left            =   720
      TabIndex        =   2
      Top             =   720
      Width           =   615
   End
   Begin VB.TextBox txtNumTrials 
      Height          =   285
      Left            =   840
      TabIndex        =   1
      Text            =   "10000"
      Top             =   120
      Width           =   1095
   End
   Begin VB.Label lblJoin 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   840
      TabIndex        =   6
      Top             =   1800
      Width           =   1095
   End
   Begin VB.Label lblLoop 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   840
      TabIndex        =   5
      Top             =   1440
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "Join"
      Height          =   255
      Index           =   2
      Left            =   120
      TabIndex        =   4
      Top             =   1800
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Loop"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   3
      Top             =   1440
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "# Trials"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   615
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdGo_Click()
Const NUM_VALUES = 100
Dim start_time As Single
Dim stop_time As Single
Dim num_trials As Long
Dim i As Long
Dim values() As String
Dim target_num As Integer
Dim hits As Integer

    lblJoin.Caption = ""
    lblLoop.Caption = ""
    Screen.MousePointer = vbHourglass
    DoEvents

    ' Make the data.
    ReDim values(1 To NUM_VALUES)
    For i = 1 To NUM_VALUES
        values(i) = Format$(i)
    Next i
    num_trials = CLng(txtNumTrials.Text)

    Rnd -1
    Randomize 12345
    start_time = Timer
    hits = 0
    For i = 1 To num_trials
        target_num = Int(2 * Rnd * NUM_VALUES)
        If ArrayContainsJoin(values, Format$(target_num)) Then hits = hits + 1
    Next i
    stop_time = Timer
    lblJoin.Caption = Format$(stop_time - start_time, "0.0000")
    DoEvents
    Debug.Print "Join: " & hits

    Rnd -1
    Randomize 12345
    start_time = Timer
    hits = 0
    For i = 1 To num_trials
        target_num = Int(2 * Rnd * NUM_VALUES)
        If ArrayContainsLoop(values, Format$(target_num)) Then hits = hits + 1
    Next i
    stop_time = Timer
    lblLoop.Caption = Format$(stop_time - start_time, "0.0000")
    Debug.Print "Loop: " & hits

    Screen.MousePointer = vbDefault
End Sub
' Return True if the target is in the array.
Public Function ArrayContainsJoin(values() As String, ByVal target As String) As Boolean
Dim combined As String

    combined = vbNullChar & Join(values, vbNullChar) & vbNullChar
    target = vbNullChar & target & vbNullChar
    ArrayContainsJoin = (InStr(combined, target) > 0)
End Function
' Return True if the target is in the array.
Public Function ArrayContainsLoop(values() As String, ByVal target As String) As Boolean
Dim i As Integer

    ' Assume we will find the target.
    ArrayContainsLoop = True
    For i = LBound(values) To UBound(values)
        If values(i) = target Then Exit Function
    Next i

    ' We didn't find the target.
    ArrayContainsLoop = False
End Function

